=== modified file 'olive/__init__.py'
--- olive/__init__.py	2006-09-30 09:18:20 +0000
+++ olive/__init__.py	2006-09-30 13:04:15 +0000
@@ -521,8 +521,8 @@
             if not self.notbranch:
                 filename = self.wt.relpath(self.path + os.sep + item)
                 
-                for rpath, id, kind, text_modified, meta_modified in delta.renamed:
-                    if rpath == filename:
+                for rpath, rpathnew, id, kind, text_modified, meta_modified in delta.renamed:
+                    if rpathnew == filename:
                         status = 'renamed'
                 for rpath, id, kind in delta.added:
                     if rpath == filename:
@@ -707,12 +707,12 @@
             if not notbranch:
                 filename = tree1.relpath(path + os.sep + item)
                 
-                for rpath, id, kind, text_modified, meta_modified in delta.renamed:
-                    if rpath == filename:
+                for rpath, rpathnew, id, kind, text_modified, meta_modified in delta.renamed:
+                    if rpathnew == filename:
                         status = 'renamed'
                 for rpath, id, kind in delta.added:
                     if rpath == filename:
-                        status = 'added'
+                        status = 'added'                
                 for rpath, id, kind, text_modified, meta_modified in delta.removed:
                     if rpath == filename:
                         status = 'removed'

=== modified file 'olive/add.py'
--- olive/add.py	2006-09-29 12:17:19 +0000
+++ olive/add.py	2006-09-30 13:04:15 +0000
@@ -15,7 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
-import sys
 
 try:
     import pygtk
@@ -68,10 +67,7 @@
                              _('Please select a file from the list,\nor choose the other option.'))
                 return
             
-            if self.wtpath == "":
-                fullpath = self.wt.abspath(filename)
-            else:
-                fullpath = self.wt.abspath(self.wtpath + os.sep + filename)
+            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
             
             try:
                 bzrlib.add.smart_add([fullpath])
@@ -81,8 +77,10 @@
                 return
         elif radio_unknown.get_active():
             # Add unknown files recursively
+            fullpath = self.wt.abspath(self.wtpath)
+            
             try:
-                bzrlib.add.smart_add([self.wtpath], True)
+                bzrlib.add.smart_add([fullpath], True)
             except errors.NotBranchError:
                 error_dialog(_('Directory is not a branch'),
                              _('You can perform this action only in a branch.'))

=== modified file 'olive/commit.py'
--- olive/commit.py	2006-09-27 21:05:19 +0000
+++ olive/commit.py	2006-09-30 13:04:15 +0000
@@ -14,22 +14,18 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import sys
-
 try:
     import pygtk
     pygtk.require("2.0")
 except:
     pass
+
 import gtk
 import gtk.glade
 import gobject
 import pango
 
-from bzrlib import version_info
-
 import bzrlib.errors as errors
-from bzrlib.workingtree import WorkingTree
 
 from dialog import error_dialog
 from olive import gladefile
@@ -74,7 +70,7 @@
         """ Display the Push dialog. """
         if self.notbranch:
             error_dialog(_('Directory is not a branch'),
-                                     _('You can perform this action only in a branch.'))
+                         _('You can perform this action only in a branch.'))
             self.close()
         else:
             if self.wt.branch.get_bound_location() is not None:
@@ -144,27 +140,27 @@
                            specific_files=specific_files)
         except errors.NotBranchError:
             error_dialog(_('Directory is not a branch'),
-                                     _('You can perform this action only in a branch.'))
+                         _('You can perform this action only in a branch.'))
             return
         except errors.LocalRequiresBoundBranch:
             error_dialog(_('Directory is not a checkout'),
-                                     _('You can perform local commit only on checkouts.'))
+                         _('You can perform local commit only on checkouts.'))
             return
         except errors.PointlessCommit:
             error_dialog(_('No changes to commit'),
-                                     _('Try force commit if you want to commit anyway.'))
+                         _('Try force commit if you want to commit anyway.'))
             return
         except errors.ConflictsInTree:
             error_dialog(_('Conflicts in tree'),
-                                     _('You need to resolve the conflicts before committing.'))
+                         _('You need to resolve the conflicts before committing.'))
             return
         except errors.StrictCommitFailed:
             error_dialog(_('Strict commit failed'),
-                                     _('There are unknown files in the working tree.\nPlease add or delete them.'))
+                         _('There are unknown files in the working tree.\nPlease add or delete them.'))
             return
         except errors.BoundBranchOutOfDate, errmsg:
             error_dialog(_('Bound branch is out of date'),
-                                     _('%s') % errmsg)
+                         _('%s') % errmsg)
             return
         except errors.BzrError, msg:
             error_dialog(_('Unknown bzr error'), str(msg))

=== modified file 'olive/dialog.py'
--- olive/dialog.py	2006-09-29 12:17:19 +0000
+++ olive/dialog.py	2006-09-30 13:04:15 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import sys
-
 try:
     import pygtk
     pygtk.require("2.0")

=== modified file 'olive/info.py'
--- olive/info.py	2006-09-27 21:05:19 +0000
+++ olive/info.py	2006-09-30 13:04:15 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import sys
-
 try:
     import pygtk
     pygtk.require("2.0")
@@ -24,12 +22,11 @@
 
 import gtk
 import gtk.glade
-import gobject
-import pango
 
 import bzrlib.errors as errors
 
 from olive import gladefile
+from dialog import error_dialog
 
 def info(location):
     """ Get info about branch, working tree, and repository
@@ -81,7 +78,7 @@
     try:
         a_bzrdir = bzrdir.BzrDir.open_containing(location)[0]
     except errors.NotBranchError:
-        raise NotBranchError(location)
+        raise errors.NotBranchError(location)
 
     try:
         working = a_bzrdir.open_workingtree()
@@ -554,7 +551,7 @@
         """ Display the Informations window. """
         if self.notbranch:
             error_dialog(_('Directory is not a branch'),
-                                     _('You can perform this action only in a branch.'))
+                         _('You can perform this action only in a branch.'))
             self.close()
         else:
             self.window.show()

=== modified file 'olive/launch.py'
--- olive/launch.py	2006-09-13 20:19:31 +0000
+++ olive/launch.py	2006-09-30 13:04:15 +0000
@@ -16,7 +16,6 @@
 
 import sys
 import os
-import string
 
 def launch(path):
     """ Launch program associated with path """

=== modified file 'olive/menu.py'
--- olive/menu.py	2006-09-30 08:48:46 +0000
+++ olive/menu.py	2006-09-30 13:04:15 +0000
@@ -210,15 +210,26 @@
     
     def diff(self, action):
         """ Right context menu -> Diff """
-        from diff import OliveDiff
-        diff = OliveDiff(self.comm)
-        diff.display()
+        from bzrlib.plugins.gtk.viz.diffwin import DiffWindow
+        
+        try:
+            wt = WorkingTree.open_containing(self.path)[0]
+        except errors.NotBranchError:
+            error_dialog(_('File is not in a branch'),
+                         _('The selected file is not in a branch.'))
+            return
+        
+        window = DiffWindow()
+        parent_tree = wt.branch.repository.revision_tree(wt.branch.last_revision())
+        window.set_diff(wt.branch.nick, wt, parent_tree)
+        window.show()
     
     def bookmark(self, action):
         """ Right context menu -> Bookmark """
-        if self.pref.add_bookmark(self.comm.get_path()):
+        if self.pref.add_bookmark(self.path):
             info_dialog(_('Bookmark successfully added'),
                         _('The current directory was bookmarked. You can reach\nit by selecting it from the left panel.'))
+            self.pref.write()
         else:
             warning_dialog(_('Location already bookmarked'),
                            _('The current directory is already bookmarked.\nSee the left panel for reference.'))

=== modified file 'olive/mkdir.py'
--- olive/mkdir.py	2006-09-27 19:52:46 +0000
+++ olive/mkdir.py	2006-09-30 13:04:15 +0000
@@ -15,7 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
-import sys
 
 try:
     import pygtk
@@ -29,6 +28,7 @@
 import bzrlib.errors as errors
 
 from olive import gladefile
+from dialog import error_dialog, warning_dialog
 
 class OliveMkdir:
     """ Display the Make directory dialog and perform the needed actions. """
@@ -44,6 +44,9 @@
         
         # Connect the signals to the handlers
         self.glade.signal_autoconnect(dic)
+        
+        self.wt = wt
+        self.wtpath = wtpath
 
     def display(self):
         """ Display the Make directory dialog. """
@@ -58,38 +61,35 @@
         
         if dirname == "":
             error_dialog(_('No directory name given'),
-                                     _('Please specify a desired name for the new directory.'))
+                         _('Please specify a desired name for the new directory.'))
             return
         
         if checkbox.get_active():
             # Want to create a versioned directory
             try:
-                from bzrlib.workingtree import WorkingTree
-    
-                os.mkdir(os.path.join(wt.base, wtpath))
+                os.mkdir(os.path.join(self.wt.basedir, self.wtpath, dirname))
 
-                wt.add([wtpath])
+                self.wt.add([os.path.join(self.wtpath, dirname)])
             except OSError, e:
                 if e.errno == 17:
                     error_dialog(_('Directory already exists'),
-                                             _('Please specify another name to continue.'))
+                                 _('Please specify another name to continue.'))
                 else:
                     raise
             except errors.NotBranchError:
                 warning_dialog(_('Directory is not in a branch'),
-                                           _('You can only create a non-versioned directory.'))
+                               _('You can only create a non-versioned directory.'))
         else:
             # Just a simple directory
             try:
-                os.mkdir(os.path.join(wt.base, wtpath))
+                os.mkdir(os.path.join(self.wt.basedir, self.wtpath, dirname))
             except OSError, e:
                 if e.errno == 17:
                     error_dialog(_('Directory already exists'),
-                                             _('Please specify another name to continue.'))
+                                 _('Please specify another name to continue.'))
                     return
 
         self.close()
-        self.comm.refresh_right()
     
     def close(self, widget=None):
         self.window.destroy()

=== modified file 'olive/move.py'
--- olive/move.py	2006-09-30 11:01:59 +0000
+++ olive/move.py	2006-09-30 13:04:15 +0000
@@ -77,21 +77,18 @@
                          _('Please select a file from the list to proceed.'))
             return
         
-        if self.wtpath == "":
-            source = self.wt.abspath(filename)
-        else:
-            source = self.wt.abspath(self.wtpath + os.sep + filename)
+        source = os.path.join(self.wtpath, filename)
         
         # Move the file to a directory
         try:
-            wt1, path1 = WorkingTree.open_containing(source)
+            wt1, path1 = WorkingTree.open_containing(self.wt.abspath(source))
             wt2, path2 = WorkingTree.open_containing(destination)
-            if wt1.base != wt2.base:
+            if wt1.basedir != wt2.basedir:
                 error_dialog(_('Not the same branch'),
                              _('The destination is not in the same branch.'))
                 return
 
-            wt1.move([source], destination)
+            wt1.move([source], wt1.relpath(destination))
         except errors.NotBranchError:
             error_dialog(_('File is not in a branch'),
                          _('The selected file is not in a branch.'))

=== modified file 'olive/push.py'
--- olive/push.py	2006-09-28 06:35:56 +0000
+++ olive/push.py	2006-09-30 13:04:15 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import sys
-
 try:
     import pygtk
     pygtk.require("2.0")
@@ -29,6 +27,7 @@
 import bzrlib.errors as errors
 
 from olive import gladefile
+from dialog import error_dialog, info_dialog
 
 class OlivePush:
     """ Display Push dialog and perform the needed actions. """
@@ -105,17 +104,17 @@
                                overwrite=self.check_overwrite.get_active())
             except errors.NotBranchError:
                 error_dialog(_('Directory is not a branch'),
-                                         _('You can perform this action only in a branch.'))
+                             _('You can perform this action only in a branch.'))
                 return
             except errors.DivergedBranches:
                 error_dialog(_('Branches have been diverged'),
-                                         _('You cannot push if branches have diverged. Use the\noverwrite option if you want to push anyway.'))
+                             _('You cannot push if branches have diverged. Use the\noverwrite option if you want to push anyway.'))
                 return
         elif self.radio_specific.get_active():
             location = self.entry_location.get_text()
             if location == '':
                 error_dialog(_('No location specified'),
-                                         _('Please specify a location or use the default.'))
+                             _('Please specify a location or use the default.'))
                 return
             
             try:
@@ -125,16 +124,16 @@
                                self.check_create.get_active())
             except errors.NotBranchError:
                 error_dialog(_('Directory is not a branch'),
-                                         _('You can perform this action only in a branch.'))
+                             _('You can perform this action only in a branch.'))
                 return
             except errors.DivergedBranches:
                 error_dialog(_('Branches have been diverged'),
-                                         _('You cannot push if branches have diverged. Use the\noverwrite option if you want to push anyway.'))
+                             _('You cannot push if branches have diverged. Use the\noverwrite option if you want to push anyway.'))
                 return
         
         self.close()
         info_dialog(_('Push successful'),
-                                _('%d revision(s) pushed.') % revs)
+                    _('%d revision(s) pushed.') % revs)
     
     def test(self, widget):
         """ Test if write access possible. """
@@ -216,7 +215,7 @@
                 transport.mkdir(relurl)
             except errors.NoSuchFile:
                 error_dialog(_('Non existing parent directory'),
-                                         _("The parent directory (%s)\ndoesn't exist.") % location)
+                             _("The parent directory (%s)\ndoesn't exist.") % location)
                 return
         else:
             current = transport.base
@@ -232,7 +231,7 @@
                                    new_transport.relpath(transport.base)))
                     if new_transport.base == transport.base:
                         error_dialog(_('Path prefix not created'),
-                                                 _("The path leading up to the specified location couldn't\nbe created."))
+                                     _("The path leading up to the specified location couldn't\nbe created."))
                         return
         dir_to = br_from.bzrdir.clone(location_url,
             revision_id=br_from.last_revision())

=== modified file 'olive/remove.py'
--- olive/remove.py	2006-09-29 22:22:20 +0000
+++ olive/remove.py	2006-09-30 13:04:15 +0000
@@ -66,10 +66,7 @@
                              _('Please select a file from the list,\nor choose the other option.'))
                 return
             
-            if self.wtpath == "":
-                fullpath = self.wt.abspath(filename)
-            else:
-                fullpath = self.wt.abspath(self.wtpath + os.sep + filename)
+            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
             
             try:
                 self.wt.remove(fullpath)

=== modified file 'olive/rename.py'
--- olive/rename.py	2006-09-30 11:01:59 +0000
+++ olive/rename.py	2006-09-30 13:04:15 +0000
@@ -71,19 +71,15 @@
                          _('Please specify a new name for the file.'))
             return
         
-        if self.wtpath == "":
-            source = self.wt.abspath(old_filename)
-            destination = self.wt.abspath(new_filename)
-        else:
-            source = self.wt.abspath(self.wtpath + os.sep + old_filename)
-            destination = self.wt.abspath(self.wtpath + os.sep + new_filename)
+        source = os.path.join(self.wtpath, old_filename)
+        destination = os.path.join(self.wtpath, new_filename)
         
         # Rename the file
         try:
-            wt1, path1 = WorkingTree.open_containing(source)
-            wt2, path2 = WorkingTree.open_containing(source)
+            wt1, path1 = WorkingTree.open_containing(self.wt.abspath(source))
+            wt2, path2 = WorkingTree.open_containing(self.wt.abspath(source))
 
-            if wt1.base != wt2.base:
+            if wt1.basedir != wt2.basedir:
                 error_dialog(_('Not the same branch'),
                              _('The destination is not in the same branch.'))
                 return
@@ -92,6 +88,8 @@
             error_dialog(_('File is not in a branch'),
                          _('The selected file is not in a branch.'))
             return
+        except errors.BzrError, msg:
+            error_dialog(_('Unknown bzr error'), str(msg))
 
         self.close()
     

=== modified file 'olive/status.py'
--- olive/status.py	2006-09-28 06:35:56 +0000
+++ olive/status.py	2006-09-30 13:04:15 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import sys
-
 try:
     import pygtk
     pygtk.require("2.0")
@@ -24,16 +22,6 @@
 
 import gtk
 import gtk.glade
-import gobject
-import pango
-
-import bzrlib
-import bzrlib.errors as errors
-
-from bzrlib.status import show_tree_status
-from bzrlib.workingtree import WorkingTree
-
-from dialog import error_dialog
 
 from olive import gladefile
 
@@ -45,6 +33,7 @@
         
         # Get the Status window widget
         self.window = self.glade.get_widget('window_status')
+        
         self.wt = wt
         self.wtpath = wtpath
         

